"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/hasura.ts
var hasura_exports = {};
__export(hasura_exports, {
  ClientOptionsSchema: () => ClientOptionsSchema,
  createHasuraClient: () => createHasuraClient,
  readFragment: () => import_gql2.readFragment
});
module.exports = __toCommonJS(hasura_exports);
var import_logging = require("@settlemint/sdk-utils/logging");
var import_runtime = require("@settlemint/sdk-utils/runtime");
var import_validation = require("@settlemint/sdk-utils/validation");
var import_gql = require("gql.tada");
var import_graphql_request = require("graphql-request");
var import_zod = require("zod");
var import_gql2 = require("gql.tada");
var ClientOptionsSchema = import_zod.z.object({
  instance: import_validation.UrlOrPathSchema,
  accessToken: import_validation.ApplicationAccessTokenSchema,
  adminSecret: import_zod.z.string(),
  cache: import_zod.z.enum(["default", "force-cache", "no-cache", "no-store", "only-if-cached", "reload"]).optional()
});
function createHasuraClient(options, clientOptions, logger) {
  (0, import_runtime.ensureServer)();
  const validatedOptions = (0, import_validation.validate)(ClientOptionsSchema, options);
  const graphql = (0, import_gql.initGraphQLTada)();
  const fullUrl = new URL(validatedOptions.instance).toString();
  return {
    client: new import_graphql_request.GraphQLClient(fullUrl, {
      ...clientOptions,
      headers: {
        ...clientOptions?.headers ?? {},
        "x-auth-token": validatedOptions.accessToken,
        "x-hasura-admin-secret": validatedOptions.adminSecret
      },
      fetch: logger ? (0, import_logging.requestLogger)(logger, "hasura", fetch) : fetch
    }),
    graphql
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ClientOptionsSchema,
  createHasuraClient,
  readFragment
});
//# sourceMappingURL=hasura.cjs.map